ig.module
(
	'game.blood'
)
.requires
(
	'impact.entity',
	'impact.entity-pool'
)
.defines(function()
{
	Blood = ig.Entity.extend(
	{
		animSheet: new ig.AnimationSheet('media/blood.png', 1, 1),
		size: { x: 1, y: 1 },
		offset: { x: 0, y: 0 },
		zIndex: 46,

		type: ig.Entity.TYPE.B,

		gravityFactor: 1,

		maxVel: { x: 30, y: 30 },
		accel: { x: 0, y: 0 },

		dir: 0,

		timer: 0,
		remove: false,
		
		init: function(x, y, settings)
		{
			this.parent(x, y, settings);

			this.reset(x, y, settings);
		},

		reset: function(x, y, settings)
		{
			this.parent(x, y, settings);

			this.addAnim('idle', 1, [0 + 8 * Math.random()]);

			this.bounciness = 0.2 + 0.2 * Math.random();

			this.vel.x = this.dir * (40 + 40 * Math.random());		
			this.vel.y = -(40 + 50 * Math.random());
			this.friction.x = 5 + Math.random() * 5;
			this.friction.y = 5 + Math.random() * 5;

	    	this.gravityFactor = 1;

			this.timer = new ig.Timer();
			this.remove = false;
		},

		update: function()
		{
			this.parent();

			if (this.pos.x < -2 || this.pos.x > ig.system.width + 2 || this.pos.y > ig.system.height + 2)
				this.kill();

			if (this.remove && this.timer.delta() > 0)
				this.kill();
		},

		handleMovementTrace: function(res)
		{
		    if(res.collision.y || res.collision.x)
		    {
		    	this.timer.set(1 + 5 * Math.random());
		    	this.remove = true;
		    	this.vel.x = 0;
		    	this.vel.y = 0;
		    	this.gravityFactor = 0;
			}

			this.parent(res);
		},
		
		kill: function()
		{
			this.parent();
		},

	    receiveDamage: function(amount, from)
	    {
	    },
	});

	Blood2 = Blood.extend(
	{
		animSheet: new ig.AnimationSheet('media/blood2.png', 1, 1),
	});

	ig.EntityPool.enableFor(Blood);
	ig.EntityPool.enableFor(Blood2);

});