ig.module
(
	'game.bullet'
)
.requires
(
	'impact.entity',
	'impact.entity-pool'
)
.defines(function()
{
	Bullet = ig.Entity.extend(
	{
		animSheet: new ig.AnimationSheet('media/bullet1.png', 1, 1),
		size: { x: 1, y: 1 },
		offset: { x: 0, y: 0 },
		zIndex: 44,
		type: ig.Entity.TYPE.NONE,
		checkAgainst: ig.Entity.TYPE.B,

		gravityFactor: 0,

		maxVel: { x: 200, y: 0 },
		accel: { x: 0, y: 0 },
		
		dir: 1,

		init: function(x, y, settings)
		{
			this.parent(x, y, settings);

			this.reset(x, y, settings);
		},

		reset: function(x, y, settings)
		{
			this.parent(x, y, settings);

			this.addAnim('idle', 1, [0]);

			this.vel.x = this.dir * 200;
		},

		update: function()
		{
			this.parent();

			if (this.pos.x < -2 || this.pos.x > ig.system.width + 2 || this.pos.y > ig.system.height + 2)
				this.kill();
		},

		handleMovementTrace: function(res)
		{
		    if(res.collision.y || res.collision.x)
		    {
		    	this.kill();
			}

			this.parent(res);
		},

		check: function(other)
		{
			if (other instanceof EntityZombie)
			{
				if (other.receiveDamage(1, this))
					this.kill();
			}
		},

		kill: function()
		{
			this.parent();
		},

	    receiveDamage: function(amount, from)
	    {
	    	ig.log("KILLED");
	    },

	    kill: function()
		{
			this.parent();
		},

	    receiveDamage: function(amount, from)
	    {
	    },
	});

	ig.EntityPool.enableFor(Bullet);

});