ig.module
(
	'game.dirt'
)
.requires
(
	'impact.entity',
	'impact.entity-pool'
)
.defines(function()
{
	Dirt = ig.Entity.extend(
	{
		animSheet: new ig.AnimationSheet('media/dirt.png', 1, 1),
		size: { x: 1, y: 1 },
		offset: { x: 0, y: 0 },
		zIndex: 40,

		gravityFactor: 1,

		maxVel: { x: 30, y: 30 },
		accel: { x: 0, y: 0 },
		
		init: function(x, y, settings)
		{
			this.parent(x, y, settings);

			this.reset(x, y, settings);
		},

		reset: function(x, y, settings)
		{
			this.parent(x, y, settings);

			this.addAnim('idle', 1, [0 + 8 * Math.random()]);

			this.bounciness = 0.2 + 0.2 * Math.random();

			this.vel.x = -15 + 30 * Math.random();		
			this.vel.y = -(60 + 80 * Math.random());
			this.friction.x = 5 + Math.random() * 5;
			this.friction.y = 5 + Math.random() * 5;
		},

		update: function()
		{
			this.parent();

			if (this.pos.x < -2 || this.pos.x > ig.system.width + 2 || this.pos.y > ig.system.height + 2)
				this.kill();
		},

		handleMovementTrace: function(res)
		{
		    if(res.collision.y || res.collision.x)
		    {
		    	this.kill();
			}

			this.parent(res);
		},

		kill: function()
		{
			this.parent();
		},

	    receiveDamage: function(amount, from)
	    {
	    },
	});

	ig.EntityPool.enableFor(Dirt);

});