ig.module
(
	'game.entities.rain-spawner'
)
.requires
(
	'impact.entity',
	'game.rain'
)
.defines(function()
{
	EntityRainSpawner = ig.Entity.extend(
	{
		size: { x: 16, y: 16},
		gravityFactor: 0,
		type: ig.Entity.TYPE.NONE,
		collides: ig.Entity.COLLIDES.NEVER,
		zIndex: 9999,
		gravityFactor: 0,

		_wmScalable: true,
    	_wmDrawBox: true,
    	_wmBoxColor: 'rgba(255, 255, 255, 0.7)',

    	spawn_timer: null,
    	spawn_num: 50,

    	lightning: true,
    	lightning_img: new ig.Image('media/lightning.png'),
    	lightning_timer: null,
    	lightning_visible: false,
    	lightning_sounds: [ new ig.Sound('media/thunder2.*')],

		init: function(x, y, settings)
		{
			this.parent(x, y, settings);

			this.spawn_timer = new ig.Timer();
			this.spawn_timer.set(0);

			this.lightning_timer = new ig.Timer();
			this.lightning_timer.set(5 * Math.random());
		},

		update: function()
		{
			if (this.lightning_timer.delta() > 0)
			{
				if (this.lightning_visible)
				{
					this.lightning_visible = false;
					this.lightning_timer.set(10 + 20 * Math.random());
				}
				else
				{
					this.lightning_visible = true;
					this.lightning_timer.set(0.11);					
					this.lightning_sounds[Math.floor(Math.random() * this.lightning_sounds.length)].play();
				}
			}

			if (this.spawn_timer.delta() > 0)
			{
				for (var i = 0; i < this.spawn_num; ++i)
					ig.game.spawnEntity(Rain, this.pos.x + Math.random() * this.size.x, this.pos.y-4);
				
				this.spawn_timer.set(0.2);
			}
		},

		draw: function()
		{
			this.parent();

			if (this.lightning_visible)
				this.lightning_img.draw(0, 0);
		},

		kill: function()
		{
		},

	    receiveDamage: function(amount, from)
	    {
	    },
	});
});