ig.module
(
	'game.entities.zombie-spawner'
)
.requires
(
	'impact.entity',
	'game.entities.zombie'
)
.defines(function()
{
	EntityZombieSpawner = ig.Entity.extend(
	{
		spawn_sound: new ig.Sound('media/rise.*'),
	    animSheet: new ig.AnimationSheet('media/tombstone.png', 16, 16),
		size: { x: 16, y: 16},
		gravityFactor: 0,
		type: ig.Entity.TYPE.B,
		collides: ig.Entity.COLLIDES.NEVER,
		checkAgainst: ig.Entity.TYPE.B,
		zIndex: 0,
		gravityFactor: 0,

    	spawn_timer: null,

    	blood_hit: 0,

		init: function(x, y, settings)
		{
			this.parent(x, y, settings);

	        this.addAnim('idle', 1, [0]);
	        this.addAnim('blood', 0.5, [1, 2, 3, 4, 4, 4], true);
	        this.addAnim('rain', 0.5, [4, 5, 6, 7, 8, 9, 0], true);

			this.spawn_timer = new ig.Timer();
			this.spawn_timer.set(5 + Math.random() * 10);
		},

		update: function()
		{
			this.parent();

			if (this.spawn_timer.delta() > 0)
			{
				this.spawn_sound.play();

				ig.game.spawnEntity(EntityZombie, -16 + this.pos.x + 33 * Math.random(), this.pos.y);
				
				this.spawn_timer.set(10 + Math.random() * 20);
			}
		},

		kill: function()
		{
		},

	    receiveDamage: function(amount, from)
	    {
	    },

		check: function(other)
		{
			if (other instanceof Blood2)
				return;

			if (other instanceof Blood)
			{
				if (!other.remove)
					this.blood_hit += 1;

				if (this.blood_hit > 10)
				{
					if (this.currentAnim == this.anims.rain)
					{
						if (this.currentAnim.frame >= 6)
							this.currentAnim = this.anims.blood.rewind();
					}	
					else if (this.currentAnim == this.anims.idle)
						this.currentAnim = this.anims.blood.rewind();				
				}
			}
		},

		rain: function()
		{
			if (this.currentAnim == this.anims.blood && this.currentAnim.frame >= 5)
			{
				this.currentAnim = this.anims.rain.rewind();
				this.blood_hit = 0;
			}
		},
	});
});