ig.module
( 
	'game.game' 
)
.requires
(
	'impact.game',
	'impact.font',
	'game.gameover',
	'game.levels.0'
)
.defines(function()
{
	Game = ig.Game.extend(
	{
		font: new ig.Font( 'media/04b03_27.font.png' ),
		sky_img: new ig.Image('media/sky.png'),

		autoSort: true,
		clearColor: null,
		gravity: 300,

		is_gameover: false,
		gameover_timer: null,

		init: function()
		{
			ig.music.play();

			ig.global.ld29_player_score = 0;

			this.is_gameover = false;

			this.loadLevel(Level0);
		},
	
		update: function()
		{
			if (this.is_gameover && this.gameover_timer.delta() > 0)
			{
				ig.system.setGame(Gameover);
			}
			else
			{
				this.parent();
			}
		},
	
		draw: function()
		{
			this.sky_img.draw(0, 0);

			this.parent();

			this.font.draw(ld29_player_score, ig.system.width * 0.5, 8, ig.Font.ALIGN.CENTER);
		},

		start_gameover: function()
		{
			this.is_gameover = true;
			this.gameover_timer = new ig.Timer(3);
		},
	});
});
