ig.module
( 
	'game.main' 
)
.requires
(
//	'impact.debug.debug',
	'impact.game',
	'impact.font',
	'game.game'
)
.defines(function()
{
	ig.global.ld29_player_score = 0;

	LD29 = ig.Game.extend(
	{
		font: new ig.Font( 'media/04b03_27.font.png' ),
		music1: new ig.Sound('media/music1.*'),
		splash_img: new ig.Image('media/splash.png'),

		timer: null,

		init: function()
		{
			ig.music.add(this.music1);
			ig.music.loop = true;
			ig.music.volume = 1;

			ig.input.bind(ig.KEY.UP_ARROW, 'jump');
			ig.input.bind(ig.KEY.LEFT_ARROW, 'left');
			ig.input.bind(ig.KEY.RIGHT_ARROW, 'right');
			ig.input.bind(ig.KEY.W, 'jump');
			ig.input.bind(ig.KEY.A, 'left');
			ig.input.bind(ig.KEY.D, 'right');
			ig.input.bind(ig.KEY.SPACE, 'shoot');
			ig.input.bind(ig.KEY.ENTER, 'shoot');
			ig.input.bind(ig.KEY.ESC, 'back');

			this.timer = new ig.Timer(5);
		},
	
		update: function()
		{
			if (ig.input.pressed('shoot') || this.timer.delta() > 0)
				ig.system.setGame(Game);
		},
	
		draw: function()
		{
			this.parent();
			this.splash_img.draw(0, 0);
		},
	});

	ig.Sound.use = [ ig.Sound.FORMAT.OGG, ig.Sound.FORMAT.M4A ];

	var scale = 1;	
	if (window.innerWidth >= 1280 && window.innerHeight >= 960)
		scale = 2;

	ig.main('#canvas', LD29, 60, 640, 480, scale);
});
