ig.module
(
	'game.rain'
)
.requires
(
	'impact.entity',
	'impact.entity-pool'
)
.defines(function()
{
	Rain = ig.Entity.extend(
	{
		animSheet: new ig.AnimationSheet('media/rain.png', 1, 2),
		size: { x: 1, y: 2 },
		offset: { x: 0, y: 0 },
		zIndex: 41,
		gravityFactor: 0,
		checkAgainst: ig.Entity.TYPE.BOTH,
		type: ig.Entity.TYPE.NONE,
		
		timer: null,
		hit_ground: false,

		max_timer: null,

		maxVel: { x: 10, y: 1200 },
		
		init: function(x, y, settings)
		{
			this.parent(x, y, settings);

			this.reset(x, y, settings);
		},

		reset: function(x, y, settings)
		{
			this.parent(x, y, settings);

			this.addAnim('idle', 1, [0 + 8 * Math.random()]);

			this.bounciness = 0.2 + 0.2 * Math.random();

			this.vel.x = -2 + 4 * Math.random();		
			this.vel.y = 50 + 100 * Math.random();
			this.accel.x = -2 + 4 * Math.random();			
			this.accel.y = 50 + 30 * Math.random();

			this.timer = new ig.Timer();
			this.max_timer = new ig.Timer(10);

			this.hit_ground = false;
		},

		update: function()
		{
			this.parent();

			if (this.pos.x < -2 || this.pos.x > ig.system.width + 2 || this.pos.y > ig.system.height + 2)
				this.kill();

			if (this.max_timer.delta() > 0)
			{
				this.kill();
			}

			if (this.hit_ground && this.timer.delta() > 0)
				this.kill();
		},

		handleMovementTrace: function(res)
		{
		    if(res.collision.y)
		    {
		    	this.vel.y *= 0.5;
		    	this.accel.x = 0;
		    	this.accel.y = 0;
				this.timer.set(0.1 + 0.1 * Math.random());
				this.hit_ground = true;
			}

			this.parent(res);
		},

		check: function(other)
		{
			this.vel.y *= -0.5;
		    this.accel.x = 0;
		    this.accel.y = 0;
			this.timer.set(0.01 + 0.1 * Math.random());
			this.hit_ground = true;

			if (other instanceof EntityZombieSpawner)
				other.rain();
			
			if (other instanceof EntityPlayer)
				other.rain();
		},

		kill: function()
		{
			this.parent();
		},

	    receiveDamage: function(amount, from)
	    {
	    },
	});

	ig.EntityPool.enableFor(Rain);

});